﻿Imports System
Imports System.IO
Imports System.Text

Public Class Form1
    Dim stopIt As Boolean = False
    Dim linesCount As Integer = 0
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            stopIt = False
            linesCount = 0
            Dim filepath As String
            If OpenFileDialog1.ShowDialog() <> Windows.Forms.DialogResult.OK Then Exit Sub

            filepath = OpenFileDialog1.FileName
            If filepath <> "" Then
                ErrorLog.Text = "Errors Log:" & vbCrLf
                'apri il file e inizia a prendere una riga alla volta fino all'ultima riga
                Dim sr As StreamReader = New StreamReader(filepath)

                Do While sr.Peek() >= 0
                    Dim curLine = sr.ReadLine()
                    linesCount = linesCount + 1
                    Dim arr() = curLine.Split(" ")
                    If arr.Length > 15 Then
                        Dim byteArr(15) As Byte
                        For i As Integer = 1 To 16 Step 1
                            If (arr(i).Length <> 2) Then
                                ErrorLog.Text = ErrorLog.Text & "Note, on line " & linesCount & ": Byte" & (i - 1) & " is not composed by 2 characters" & vbCrLf
                            End If
                            'salva sull'array di byte
                            Try
                                byteArr(i - 1) = Convert.ToByte(Convert.ToInt32(arr(i), 16))
                            Catch ex As Exception
                                ErrorLog.Text = ErrorLog.Text & "Error on line " & linesCount & ": Byte" & (i - 1) & " -> " & ex.Message & vbCrLf
                                byteArr(i - 1) = 0
                            End Try

                            If stopIt Then
                                StatusTextbox.Text = "Process Stopped by user! " & StatusTextbox.Text
                                Exit Sub
                            End If
                        Next
                        'alla fine salva su file
                        AppendByteToDisk(filepath & ".bin", byteArr)
                        StatusTextbox.Text = "Lines Read From original File: " & linesCount & ", bytes saved in binary file: " & linesCount * 16
                        Application.DoEvents()
                        If stopIt Then
                            StatusTextbox.Text = "Process Stopped by user! " & StatusTextbox.Text
                            Exit Sub
                        End If
                    End If
                    If stopIt Then
                        StatusTextbox.Text = "Process Stopped by user! " & StatusTextbox.Text
                        Exit Sub
                    End If
                Loop
                sr.Close()
                
                'aggiorna la progress bar 
                StatusTextbox.Text = "Process Completed! " & StatusTextbox.Text

            End If

        Catch ex As Exception
            ErrorLog.Text = ErrorLog.Text & "Error on line " & linesCount & ": " & ex.Message & vbCrLf
            StatusTextbox.Text = "Process aborted due to errors! " & StatusTextbox.Text
        End Try
    End Sub

    Private Sub AppendByteToDisk(ByVal FilepathToAppendTo As String, ByRef Content() As Byte)
        Dim s As New System.IO.FileStream(FilepathToAppendTo, System.IO.FileMode.Append, System.IO.FileAccess.Write, System.IO.FileShare.ReadWrite)
        s.Write(Content, 0, Content.Length)
        s.Close()
    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        stopIt = True
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
